package org.iphsoft.simon1;

import org.iphsoft.simon1.util.DeviceIdentifier.DeviceModel;
import org.iphsoft.simon1.util.MyLog;

public abstract class DeviceConfigurations {

	public static synchronized DeviceConfigurations instance()
	{
		if (sInstance == null)
		{
			switch (AndroidPortAdditions.GAME_TYPE)
			{
			case FOTAQ:
				sInstance = new DeviceConfigurationsFOTAQ();
				break;
			case INDY_FOA:
			case SIMON1:
			case SIMON2:
			case IHNM:
				sInstance = new DeviceConfigurationsSTS();
				break;
			case T7G:
				sInstance = new DeviceConfigurationsT7G();
				break;
			default:
				throw new RuntimeException("Unknown game");
			}
			
			MyLog.d("DeviceConfigurations: instance: class type: " + sInstance.getClass().getName());
		}

		return sInstance;
	}

	public abstract String[] getDevicesUsingUltraMode();
	public abstract String[] getGPUKindsUsingUltraMode();
	public abstract String[] getDevicesUsingHardwareScaler();
	public abstract String[] getDevicesUsingLQHardwareScaler();
	public abstract String[] getGPUKindsUsingHardwareScalerTest();
	public abstract String[] getGPUKindsUsingSoftwareScaler();
	public abstract String[] getGPUKindsUsingLQHardwareScalerTest();
	public abstract String[] getGPUKindsUsingLQHardwareScaler();

	public abstract DeviceModel[] getDevicesUsingMT32Emu();


	private static DeviceConfigurations sInstance = null;
}
