package org.iphsoft.simon1.stats;

//deprecated
//import org.iphsoft.simon1.InGameFacebookActivity.State;

//TODO: update to new GoogleAnalytics lib

import android.app.Activity;
import android.app.Application;

import com.google.android.gms.analytics.GoogleAnalytics;
import com.google.android.gms.analytics.HitBuilders;
import com.google.android.gms.analytics.Tracker;
import com.R;

import org.iphsoft.simon1.util.MyLog;


public class GoogleAnalyticsStatistics implements IStatistics {

	/**
	 * This is a subclass of {@link Application} used to provide shared objects for this app, such as
	 * the {@link Tracker}.
	 */
	public static class GoogleAnalyticsApplication extends Application {

		private static GoogleAnalytics sAnalytics;
		private static Tracker sTracker;

		@Override
		public void onCreate() {
			super.onCreate();

			sAnalytics = GoogleAnalytics.getInstance(this);
		}

		/**
		 * Gets the default {@link Tracker} for this {@link Application}.
		 * @return tracker
		 */
		synchronized public Tracker getDefaultTracker() {
			// To enable debug logging use: adb shell setprop log.tag.GAv4 DEBUG
			if (sTracker == null) {
				sTracker = sAnalytics.newTracker(R.xml.analytics);
			}

			return sTracker;
		}
	}

/*
	public GoogleAnalyticsStatistics() {

		Context ctx = ScummVMApplication.getContext();

		// For testing
		// GoogleAnalytics.getInstance(ctx).getLogger().setLogLevel(LogLevel.VERBOSE);


		sAnalytics = GoogleAnalytics.getInstance(this);

		/**
		 * Gets the default {@link Tracker} for this {@link Application}.
		 * @return tracker
		 */
/*
		synchronized public Tracker getDefaultTracker() {
			// To enable debug logging use: adb shell setprop log.tag.GAv4 DEBUG
			if (mTracker == null) {
				mTracker = sAnalytics.newTracker(R.xml.analytics);
			}

			return mTracker;
		};

		mTracker.enableAutoActivityTracking(true);
	}
*/

	@Override
	public void reportGameStart(SettingsInfo settingsInfo)
	{
		MyLog.d("GoogleAnalyticsStatistics: reportGameStart: ");

		// Obtain the shared Tracker instance.
		//GoogleAnalyticsApplication application = (GoogleAnalyticsApplication) getApplication();
		//mTracker = application.getDefaultTracker();

		// Send an app view event, along with all the custom fields for settings
		mTracker.send(new HitBuilders
				.EventBuilder()
				.setCategory("Game Start")
				.setAction(settingsInfo.mGraphicModeType)
				.setAction(settingsInfo.mGraphicMode)
				.setAction(settingsInfo.mVoiceMode)
				.setAction(settingsInfo.mMusicMode)
				.setAction(settingsInfo.mControlMode)
				.setAction(settingsInfo.mLanguage).build());

		// For testing - dispatch immediately
		// GAServiceManager.getInstance().dispatchLocalHits();
	}

	@Override
	public void reportDeviceAndGPU(String device, String gpu)
	{
		// Send an app view event, along with all the custom fields for settings
		mTracker.send(new HitBuilders
				.EventBuilder()
				.setCategory("Graphic mode initialization")
				.setAction(device)
				.setAction(gpu).build());

	}

	public void reportActivityStart(Activity activity)
	{
		//mTracker.activityStart(activity);
	}

	public void reportActivityStop(Activity activity)
	{
		//mTracker.activityStop(activity);
	}

	public void reportShareClicked()
	{
		mTracker.send(new HitBuilders
				.EventBuilder()
				.setAction("ui_action")
				.setAction("button_press")
				.setAction("share").build());
	}

	/* deprecated

	@Override
	public void reportAchievementShareClick(int achievementId)
	{
		mTracker.send(MapBuilder.createEvent("ui_action", "button_press", "achievement share",
				Long.valueOf(achievementId)).build());
	}

	@Override
	public void reportInGameFacebookDialogState(State state)
	{
		mTracker.send(MapBuilder.createEvent("dialog_result", "facebook_in_game_dialog",
				state.name(), Long.valueOf(state.ordinal())).build());
	}

	@Override
	public void reportFacebookLogin(Activity activity)
	{
		mTracker.send(MapBuilder.createEvent("facebook", "logged_in",
				"from activity: " + activity.getClass().getName(), null).build());

		mTracker.send(MapBuilder.createAppView().set(Fields.SCREEN_NAME, "Facebook log-in state")
				.set(Fields.customDimension(FACEBOOK_LOGGED_IN_STATE_DIMENSION_INDEX), "logged in")
				.build());
	}

	@Override
	public void reportFacebookLogout(Activity activity)
	{
		mTracker.send(MapBuilder.createEvent("facebook", "logged_out",
				"from activity: " + activity.getClass().getName(), null).build());

		mTracker.send(MapBuilder
				.createAppView()
				.set(Fields.SCREEN_NAME, "Facebook log-in state")
				.set(Fields.customDimension(FACEBOOK_LOGGED_IN_STATE_DIMENSION_INDEX), "logged out")
				.build());
	}

	@Override
	public void reportSuccessfulAchievementPost(int achievementId, String shareMessage)
	{
		MyLog.d("GoogleAnalyticsStatistics: reportSuccessfulAchievementPost: id " + achievementId + " message " + shareMessage);
		
		mTracker.send(MapBuilder.createEvent("facebook", "achievement_share",
				shareMessage != null ? "achievement_share_explicit" : "achievement_share_implicit",
				Long.valueOf(achievementId)).build());

		if (shareMessage != null)
		{
			mTracker.send(MapBuilder
					.createAppView()
					.set(Fields.SCREEN_NAME, "successful explicit share")
					.set(Fields.customDimension(ACHIEVEMENT_SHARE_MESSAGE_DIMENSION_INDEX),
							shareMessage).build());
		}
	}
	*/

	private Tracker mTracker;

	private static final int GRAPHIC_SETTING_TYPE_DIMENSION_INDEX = 1;
	private static final int GRAPHIC_SETTING_DIMENSION_INDEX = 2;
	private static final int VOICE_SETTING_DIMENSION_INDEX = 3;
	private static final int MUSIC_SETTING_DIMENSION_INDEX = 4;
	private static final int CONTROL_SETTING_DIMENSION_INDEX = 5;
	private static final int LANGUAGE_SETTING_DIMENSION_INDEX = 6;
	private static final int GPU_KIND_DIMENSION_INDEX = 7;
	private static final int DEVICE_NAME_DIMENSION_INDEX = 8;
	private static final int FACEBOOK_LOGGED_IN_STATE_DIMENSION_INDEX = 9;
	private static final int ACHIEVEMENT_SHARE_MESSAGE_DIMENSION_INDEX = 10;

}
