package org.iphsoft.simon1.ui;

import android.content.Context;
import android.graphics.drawable.ColorDrawable;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.R;

import org.iphsoft.simon1.util.MediaPlayerHelper;

public class IHNMListView extends ListView {

	
	public class IHNMAdapter extends BaseAdapter
	{

		@Override
		public int getCount()
		{
			// TODO Auto-generated method stub
			return (mTitles == null ? 0 : mTitles.length);
		}

		@Override
		public Object getItem(int position)
		{
			return (mTitles == null ? null : mTitles[position]);
		}

		@Override
		public long getItemId(int position)
		{
			return position;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent)
		{
			View view = convertView;
			if (view == null)
			{
				view = LayoutInflater.from(getContext()).inflate(R.layout.settings_list_row, null);
			}
			
			View bg = view.findViewById(R.id.rowSelector);
			if (getCheckedItemPosition() == position)
			{
				bg.setVisibility(View.VISIBLE);
			}
			else
			{
				bg.setVisibility(View.GONE);
			}
			
			TextView txtTitle = (TextView)view.findViewById(R.id.txtTitle);
			txtTitle.setText(mTitles[position]);
			
			TextView txtDesc = (TextView)view.findViewById(R.id.txtDesc);
			if (mDescriptions != null)
			{
				txtDesc.setText(mDescriptions[position]);
			}
			else
			{
				txtDesc.setVisibility(View.GONE);
			}
	
			return view;
		}
		
	}
	
	public IHNMListView(Context context)
	{
		super(context);
		
		init();
	}

	public IHNMListView(Context context, AttributeSet attrs, int defStyleAttr)
	{
		super(context, attrs, defStyleAttr);
		
		init();
	}

	public IHNMListView(Context context, AttributeSet attrs)
	{
		super(context, attrs);
		
		init();
	}

	public void init()
	{
		mAdapter = new IHNMAdapter();
		setAdapter(mAdapter);
		
		setChoiceMode(CHOICE_MODE_SINGLE);
		
		setSelector(new ColorDrawable(getContext().getResources().getColor(android.R.color.transparent)));
		
		setDivider(null);
		
		super.setOnItemClickListener(new OnItemClickListener()
		{

			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int pos, long arg3)
			{
				MediaPlayerHelper.playAudioResource(getContext(), R.raw.click);

				IHNMListView.this.setItemChecked(pos, true);
				IHNMListView.this.refresh();
				
				if (mClickListener != null)
				{
					mClickListener.onItemClick(arg0, arg1, pos, arg3);
				}
			}
		});
	}
	
	@Override
	public void setOnItemClickListener(android.widget.AdapterView.OnItemClickListener listener)
	{
		mClickListener = listener;
	}
	
	public void setEntries(CharSequence[] titles, CharSequence[] descriptions)
	{
		mTitles = titles;
		mDescriptions = descriptions;

		refresh();
	}
	
	public void refresh()
	{
		mAdapter.notifyDataSetChanged();
	}
	
	private IHNMAdapter mAdapter;
	
	private CharSequence[] mTitles = null;
	private CharSequence[] mDescriptions = null;
	
	private OnItemClickListener mClickListener = null;
	
}
