package org.iphsoft.simon1.util;

import org.iphsoft.simon1.AndroidPortAdditions;
import org.iphsoft.simon1.ScummVMApplication;

import android.content.res.AssetFileDescriptor;
import android.media.AudioManager;
import android.media.MediaPlayer;

public class BackgroundMusicPlayer {

	public static void addBackgroundMusicActivity()
	{
		++sActivityCount;
		if (sActivityCount == 1)
		{
			start();
		}
	}
	
	public static void removeBackgroundMusicActivity()
	{
		--sActivityCount;
		if (sActivityCount <= 0)
		{
			stop();
		}
	}

	private static void start()
	{
		try
		{
			String filename = "bgmusic.mp3";
		
			AssetFileDescriptor afd = ScummVMApplication.getContext().getAssets().openFd(filename);
			sBgMusicPlayer = new MediaPlayer();
			sBgMusicPlayer.setDataSource(afd.getFileDescriptor(), afd.getStartOffset(),
					afd.getLength());
			sBgMusicPlayer.setLooping(true);
			sBgMusicPlayer.setVolume(0.6f, 0.6f);
			sBgMusicPlayer.setAudioStreamType(AudioManager.STREAM_MUSIC);
			sBgMusicPlayer.prepare();
			sBgMusicPlayer.start();
		} catch (Exception e)
		{
			MyLog.e("BackgroundMusicPlayer: start: couldn't start MediaPlayer!");
			MyLog.d("BackgroundMusicPlayer: start: " + e.getMessage());
			e.printStackTrace();
		}	
		
		sIsPlaying = true;
	}
	
	private static void stop()
	{
		if (sBgMusicPlayer != null && sIsPlaying)
		{
			if (sBgMusicPlayer.isPlaying())
			{
				sBgMusicPlayer.stop();
			}

			sBgMusicPlayer.release();
			
			sIsPlaying = false;
			sActivityCount = 0;
		}
	}
	
	private static boolean sIsPlaying = false;
	private static int sActivityCount = 0;
	private static MediaPlayer sBgMusicPlayer;
}
